Preview an order
Notes:
- This operation is only available if you have the Orders feature enabled. If you are an existing Zuora Subscribe and Amend customer, we recommend you enable <a href= “https://docs.zuora.com/en/zuora-billing/manage-accounts-subscriptions-and-non-subscriptions/manage-subscription-transactions/orders-harmonization” target= “_blank”>Orders Harmonization</a> to access the <a href= “https://docs.zuora.com/en/zuora-billing/manage-accounts-subscriptions-and-non-subscriptions/manage-subscription-transactions/orders/orders-introduction/overview-of-orders” target= “_blank”>Orders</a> feature. With Orders, you can access both existing functions for subscription and billing management and the new features on Zuora Billing.
- The Order Line Items feature is now generally available to all Zuora customers. You need to enable the Orders feature to access the Order Line Items feature. As of Zuora Billing Release 313 (November 2021), new customers who onboard on Orders will have the Order Line Items feature enabled by default.
- You cannot preview enhanced discounts and usage charges.
- You can skip the accounting period validation to avoid backdated subscription cancellation caused order preview failure. To skip the accounting period validation, submit a request at Zuora Global Support.
Retrieves the preview of the charge metrics and invoice items of a specified order. Preview for subscriptions and order line items are both supported. This operation is only an order preview and no order is created.
You can also use this operation to preview billing for a standalone order. For more information, see Preview billing for a standalone order.
Billing preview behavior regarding draft invoices
By default, the billing preview behavior regarding draft invoices is as below:
- When you preview billing for your order and the order contains subscriptions only, the draft invoices are excluded.
- When you preview billing for your order and the order contains order line items only, the draft invoices are included.
- When you preview billing for an order that contains both subscriptions order line items, the draft invoices are included for both subscriptions and order line items.
However, if you want to always exclude the draft invoices in billing preview, submit a request at Zuora Global Support.
Limits on Orders API
The limit of orders allowed on a subscription is 1000.
The limit of order line items allowed in an order is 100.
Zuora has the following limits on the Orders synchronous API to prevent performance degradation:
- Up to 50 subscriptions are allowed in a single Create an order or Preview an order operation call.
- Up to 50 order actions are allowed in a single Create an order or Preview an order operation call.
- Up to 50 order actions are allowed on a single subscription in a Create an order or Preview an order operation call.
If you have an Order that exceeds any limits of the above, Zuora recommends you use the following asynchronous API operations:
- Create an order asynchronously
- Preview an order asynchronously
- Retrieve the status and response of a job for checking the status of the asynchronous API operations
Zuora has the following limits on the Orders asynchronous API operations to prevent performance degradation:
- Up to 300 subscriptions are allowed in a single Create an order asynchronously or Preview an order asynchronously operation call.
- Up to 300 order actions are allowed in a single Create an order asynchronously or Preview an order asynchronously operation call.
- Up to 300 order actions are allowed on a single subscription
in a Create an order asynchronously or Preview an order asynchronously operation call.
Authentication
Use Bearer {{token}} in the Authorization header for authentication.
Headers
Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response.
If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it.
Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue.
The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote (').
An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header.
The IDs must be a sub-set of the user’s accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user’s accessible orgs.
The minor API version.
For a list of available minor versions, see API upgrades.
Query parameters
Indicates whether to return aggregated invoice item summaries for each invoice.
With this parameter set to true, the invoices > invoiceItemSummary field is returned in the preview result.
The aggregated invoiceItemSummary field provides a forecast of the number of future invoices (previewInvoiceSequence), and the following information for each invoice:
subTotaltotaltaxAmountdiscountAmountservicePeriodStartDateservicePeriodEndDate
Request
Category of the order to indicate a product sale or return. Default value is NewSales.
The account ID under which this order will be created. This field sets the default invoice owner account and subscription owner account for any new subscriptions in the order. To override these defaults for individual subscriptions, use the subscriptionOwnerAccountNumber and invoiceOwnerAccountNumber nested fields in the subscriptions field.
Note: You can specify either the existingAccountNumber or existingAccountId field, but not both.
The account number under which this order will be created. This field sets the default invoice owner account and subscription owner account for any new subscriptions in the order. To override these defaults for individual subscriptions, use the subscriptionOwnerAccountNumber and invoiceOwnerAccountNumber nested fields in the subscriptions field.
Order Line Items are non subscription based items created by an Order, representing transactional charges such as one-time fees, physical goods, or professional service charges that are not sold as subscription services.
With the Order Line Items feature enabled, you can now launch non-subscription and unified monetization business models in Zuora, in addition to subscription business models.
If you do not have the Create Order Line Items Without Product Catalog billing permission, you can only create order line items from existing products by specifying the product rate plan charge ID in the productRatePlanChargeId field. For more information about billing permissions, see Billing Roles.
Note: The Order Line Items feature is now generally available to all Zuora customers. You need to enable the Orders feature to access the Order Line Items feature. As of Zuora Billing Release 313 (November 2021), new customers who onboard on Orders will have the Order Line Items feature enabled by default.
The order number of this order.
Note: The characters #, ?, and / are not allowed in this field. Additionally, to ensure compatibility with the UI when viewing orders, use only the following special characters: _,-, ., ~, *, (, ), and '.
Values of reason code configured in Billing Settings > Configure Reason Codes through Zuora UI. Indicates the reason when a return order line item occurs.
Response headers
This header is returned if you specify the Accept-Encoding: gzip request header and the response contains over 1000 bytes of data.
Note that only the following MIME types support gzipped responses:
application/jsonapplication/xmltext/htmltext/csvtext/plain
The request limit quota for the time window closest to exhaustion. See rate limits for more information.
The number of requests remaining in the time window closest to quota exhaustion. See rate limits for more information.
The number of seconds until the quota resets for the time window closest to quota exhaustion. See rate limits for more information.
The type of the concurrency limit, which can be Default, High-volume transactions, or Object Query.
For more information, see Concurrent request limits.
The total number of the permitted concurrent requests.
For more information, see Concurrent request limits.
The remaining number of the permitted concurrent requests.
For more information, see Concurrent request limits.
Response
The container of the error code and message. This field is available only if the success field is false.